﻿#region License
/* Copyright 2013 James F. Bellinger
 * 
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event will the authors be held liable for any damages
 * arising from the use of this software.
 * 
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redestribute it
 * freely, subject to the following restrictions:
 * 
 * 1. The origin of this software must not be misrepresented; you must
 * not claim that you wrote the original software. If you use this software
 * in a product, an acknowledgement in the product documentation would be
 * appreciated but is not required.
 * 
 * 2. Altered source versions must be plainly marked as such, and must
 * not be misrepresented as being the original software.
 * 
 * 3. This notice may not be removed or altered from any source
 * distribution. */
#endregion

using System;
using System.IO;

namespace Chatter.Logic
{
    static class Directories
    {
        public static string GetPluginSettingsDirectory(string plugin)
        {
            return Path.Combine(PluginSettingsRootDirectory, plugin);
        }

        public static string GetPluginSettingsFilename(string plugin)
        {
            return Path.Combine(GetPluginSettingsDirectory(plugin), "Settings.xml");
        }

        public static string ProgramDirectory
        {
            get { return AppDomain.CurrentDomain.BaseDirectory; }
        }

        public static string PluginDirectory
        {
            get { return Path.Combine(ProgramDirectory, "Plugins"); }
        }

        public static string ProgramSettingsDirectory
        {
            get
            {
                var appData = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData);
                return Path.Combine(Path.Combine(appData, "Illusory Studios"), "Chatter");
            }
        }

        public static string ProgramSettingsFilename
        {
            get { return Path.Combine(ProgramSettingsDirectory, "Settings.xml"); }
        }

        public static string PluginSettingsRootDirectory
        {
            get { return Path.Combine(ProgramSettingsDirectory, "Plugins"); }
        }
    }
}
