#region License
/* Copyright 2004 James F. Bellinger
 * 
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event will the authors be held liable for any damages
 * arising from the use of this software.
 * 
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redestribute it
 * freely, subject to the following restrictions:
 * 
 * 1. The origin of this software must not be misrepresented; you must
 * not claim that you wrote the original software. If you use this software
 * in a product, an acknowledgement in the product documentation would be
 * appreciated but is not required.
 * 
 * 2. Altered source versions must be plainly marked as such, and must
 * not be misrepresented as being the original software.
 * 
 * 3. This notice may not be removed or altered from any source
 * distribution. */
#endregion

using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Net;
using System.Windows.Forms;
using Chatter.Logic;

namespace Chatter
{
	public class Login : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TabControl tabControl;
		private System.Windows.Forms.TabPage tabIdentity;
		private System.Windows.Forms.TabPage tabServer;
		private System.Windows.Forms.ComboBox serverEntry;
		private System.Windows.Forms.Button addButton;
		private System.Windows.Forms.Button editButton;
		private System.Windows.Forms.Button clearButton;
		private System.Windows.Forms.Button connectButton;
		private System.Windows.Forms.Button closeButton;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox textHost;
		private System.Windows.Forms.TextBox textDescribe;
		private System.Windows.Forms.TextBox textPorts;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.CheckBox identdCheck;
		private System.Windows.Forms.TextBox textNickname;
		private System.Windows.Forms.TextBox textRealName;
		private System.Windows.Forms.TextBox textUserID;
		private System.Windows.Forms.TextBox textEnvironment;
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.FontDialog fontDialog;
		private System.Windows.Forms.Label labelFontsUserListName;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.Label labelFontsChatFontSize;
		private System.Windows.Forms.Label labelFontsChatFontName;
		private System.Windows.Forms.Button btnFontsChatFont;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.TabPage tabFont;
		private System.Windows.Forms.Label labelFontsUserListSize;
		private System.Windows.Forms.Button btnFontsUserList;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Button btnFontsChannels;
		private System.Windows.Forms.Label labelFontsChannelsName;
		private System.Windows.Forms.Label labelFontsChannelsSize;
		private System.Windows.Forms.TabPage tabRobots;
		private System.Windows.Forms.ListBox listRobots;
		private System.Windows.Forms.Button btnRobotOptions;
        private CheckBox chkSSL;

		Chatter.ChatterMDI main = null;

		public Login(ChatterMDI MainWindow)
		{
			InitializeComponent();

			main = MainWindow;
		}

		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}

			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.tabControl = new System.Windows.Forms.TabControl();
            this.tabServer = new System.Windows.Forms.TabPage();
            this.chkSSL = new System.Windows.Forms.CheckBox();
            this.textPorts = new System.Windows.Forms.TextBox();
            this.textDescribe = new System.Windows.Forms.TextBox();
            this.textHost = new System.Windows.Forms.TextBox();
            this.label3 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.label1 = new System.Windows.Forms.Label();
            this.connectButton = new System.Windows.Forms.Button();
            this.clearButton = new System.Windows.Forms.Button();
            this.editButton = new System.Windows.Forms.Button();
            this.addButton = new System.Windows.Forms.Button();
            this.serverEntry = new System.Windows.Forms.ComboBox();
            this.tabIdentity = new System.Windows.Forms.TabPage();
            this.textEnvironment = new System.Windows.Forms.TextBox();
            this.textUserID = new System.Windows.Forms.TextBox();
            this.textRealName = new System.Windows.Forms.TextBox();
            this.textNickname = new System.Windows.Forms.TextBox();
            this.identdCheck = new System.Windows.Forms.CheckBox();
            this.label7 = new System.Windows.Forms.Label();
            this.label6 = new System.Windows.Forms.Label();
            this.label5 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.tabFont = new System.Windows.Forms.TabPage();
            this.labelFontsChannelsSize = new System.Windows.Forms.Label();
            this.labelFontsChannelsName = new System.Windows.Forms.Label();
            this.btnFontsChannels = new System.Windows.Forms.Button();
            this.label10 = new System.Windows.Forms.Label();
            this.btnFontsUserList = new System.Windows.Forms.Button();
            this.labelFontsUserListSize = new System.Windows.Forms.Label();
            this.labelFontsUserListName = new System.Windows.Forms.Label();
            this.label9 = new System.Windows.Forms.Label();
            this.labelFontsChatFontSize = new System.Windows.Forms.Label();
            this.labelFontsChatFontName = new System.Windows.Forms.Label();
            this.btnFontsChatFont = new System.Windows.Forms.Button();
            this.label8 = new System.Windows.Forms.Label();
            this.tabRobots = new System.Windows.Forms.TabPage();
            this.btnRobotOptions = new System.Windows.Forms.Button();
            this.listRobots = new System.Windows.Forms.ListBox();
            this.closeButton = new System.Windows.Forms.Button();
            this.fontDialog = new System.Windows.Forms.FontDialog();
            this.tabControl.SuspendLayout();
            this.tabServer.SuspendLayout();
            this.tabIdentity.SuspendLayout();
            this.tabFont.SuspendLayout();
            this.tabRobots.SuspendLayout();
            this.SuspendLayout();
            // 
            // tabControl
            // 
            this.tabControl.Controls.Add(this.tabServer);
            this.tabControl.Controls.Add(this.tabIdentity);
            this.tabControl.Controls.Add(this.tabFont);
            this.tabControl.Controls.Add(this.tabRobots);
            this.tabControl.Location = new System.Drawing.Point(8, 8);
            this.tabControl.Name = "tabControl";
            this.tabControl.SelectedIndex = 0;
            this.tabControl.Size = new System.Drawing.Size(280, 244);
            this.tabControl.TabIndex = 0;
            // 
            // tabServer
            // 
            this.tabServer.Controls.Add(this.chkSSL);
            this.tabServer.Controls.Add(this.textPorts);
            this.tabServer.Controls.Add(this.textDescribe);
            this.tabServer.Controls.Add(this.textHost);
            this.tabServer.Controls.Add(this.label3);
            this.tabServer.Controls.Add(this.label2);
            this.tabServer.Controls.Add(this.label1);
            this.tabServer.Controls.Add(this.connectButton);
            this.tabServer.Controls.Add(this.clearButton);
            this.tabServer.Controls.Add(this.editButton);
            this.tabServer.Controls.Add(this.addButton);
            this.tabServer.Controls.Add(this.serverEntry);
            this.tabServer.Location = new System.Drawing.Point(4, 22);
            this.tabServer.Name = "tabServer";
            this.tabServer.Size = new System.Drawing.Size(272, 218);
            this.tabServer.TabIndex = 0;
            this.tabServer.Text = "Server";
            // 
            // chkSSL
            // 
            this.chkSSL.AutoSize = true;
            this.chkSSL.Location = new System.Drawing.Point(80, 162);
            this.chkSSL.Name = "chkSSL";
            this.chkSSL.Size = new System.Drawing.Size(121, 17);
            this.chkSSL.TabIndex = 6;
            this.chkSSL.Text = "Use SSL Encryption";
            this.chkSSL.UseVisualStyleBackColor = true;
            // 
            // textPorts
            // 
            this.textPorts.Location = new System.Drawing.Point(80, 136);
            this.textPorts.Name = "textPorts";
            this.textPorts.Size = new System.Drawing.Size(176, 20);
            this.textPorts.TabIndex = 5;
            // 
            // textDescribe
            // 
            this.textDescribe.Location = new System.Drawing.Point(80, 112);
            this.textDescribe.Name = "textDescribe";
            this.textDescribe.Size = new System.Drawing.Size(176, 20);
            this.textDescribe.TabIndex = 4;
            // 
            // textHost
            // 
            this.textHost.Location = new System.Drawing.Point(80, 88);
            this.textHost.Name = "textHost";
            this.textHost.Size = new System.Drawing.Size(176, 20);
            this.textHost.TabIndex = 3;
            // 
            // label3
            // 
            this.label3.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.label3.Location = new System.Drawing.Point(16, 136);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(64, 16);
            this.label3.TabIndex = 7;
            this.label3.Text = "Port Range:";
            // 
            // label2
            // 
            this.label2.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.label2.Location = new System.Drawing.Point(16, 112);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(64, 16);
            this.label2.TabIndex = 6;
            this.label2.Text = "Description:";
            // 
            // label1
            // 
            this.label1.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.label1.Location = new System.Drawing.Point(16, 88);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(64, 16);
            this.label1.TabIndex = 5;
            this.label1.Text = "Host:";
            // 
            // connectButton
            // 
            this.connectButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.connectButton.Location = new System.Drawing.Point(64, 40);
            this.connectButton.Name = "connectButton";
            this.connectButton.Size = new System.Drawing.Size(144, 32);
            this.connectButton.TabIndex = 2;
            this.connectButton.Text = "Connect to chat server";
            this.connectButton.Click += new System.EventHandler(this.connectButton_Click);
            // 
            // clearButton
            // 
            this.clearButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.clearButton.Location = new System.Drawing.Point(174, 191);
            this.clearButton.Name = "clearButton";
            this.clearButton.Size = new System.Drawing.Size(64, 24);
            this.clearButton.TabIndex = 9;
            this.clearButton.Text = "Clear";
            this.clearButton.Click += new System.EventHandler(this.clearButton_Click);
            // 
            // editButton
            // 
            this.editButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.editButton.Location = new System.Drawing.Point(104, 191);
            this.editButton.Name = "editButton";
            this.editButton.Size = new System.Drawing.Size(64, 24);
            this.editButton.TabIndex = 8;
            this.editButton.Text = "Edit";
            this.editButton.Click += new System.EventHandler(this.editButton_Click);
            // 
            // addButton
            // 
            this.addButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.addButton.Location = new System.Drawing.Point(34, 191);
            this.addButton.Name = "addButton";
            this.addButton.Size = new System.Drawing.Size(64, 24);
            this.addButton.TabIndex = 7;
            this.addButton.Text = "Add";
            this.addButton.Click += new System.EventHandler(this.addButton_Click);
            // 
            // serverEntry
            // 
            this.serverEntry.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.serverEntry.Location = new System.Drawing.Point(8, 8);
            this.serverEntry.Name = "serverEntry";
            this.serverEntry.Size = new System.Drawing.Size(256, 21);
            this.serverEntry.TabIndex = 1;
            // 
            // tabIdentity
            // 
            this.tabIdentity.Controls.Add(this.textEnvironment);
            this.tabIdentity.Controls.Add(this.textUserID);
            this.tabIdentity.Controls.Add(this.textRealName);
            this.tabIdentity.Controls.Add(this.textNickname);
            this.tabIdentity.Controls.Add(this.identdCheck);
            this.tabIdentity.Controls.Add(this.label7);
            this.tabIdentity.Controls.Add(this.label6);
            this.tabIdentity.Controls.Add(this.label5);
            this.tabIdentity.Controls.Add(this.label4);
            this.tabIdentity.Location = new System.Drawing.Point(4, 22);
            this.tabIdentity.Name = "tabIdentity";
            this.tabIdentity.Size = new System.Drawing.Size(272, 218);
            this.tabIdentity.TabIndex = 1;
            this.tabIdentity.Text = "Identity";
            // 
            // textEnvironment
            // 
            this.textEnvironment.Location = new System.Drawing.Point(80, 112);
            this.textEnvironment.Name = "textEnvironment";
            this.textEnvironment.Size = new System.Drawing.Size(184, 20);
            this.textEnvironment.TabIndex = 4;
            this.textEnvironment.TextChanged += new System.EventHandler(this.textEnvironment_TextChanged);
            // 
            // textUserID
            // 
            this.textUserID.Location = new System.Drawing.Point(80, 88);
            this.textUserID.Name = "textUserID";
            this.textUserID.Size = new System.Drawing.Size(184, 20);
            this.textUserID.TabIndex = 3;
            this.textUserID.TextChanged += new System.EventHandler(this.textUserID_TextChanged);
            // 
            // textRealName
            // 
            this.textRealName.Location = new System.Drawing.Point(80, 32);
            this.textRealName.Name = "textRealName";
            this.textRealName.Size = new System.Drawing.Size(184, 20);
            this.textRealName.TabIndex = 1;
            this.textRealName.TextChanged += new System.EventHandler(this.textRealName_TextChanged);
            // 
            // textNickname
            // 
            this.textNickname.Location = new System.Drawing.Point(80, 8);
            this.textNickname.Name = "textNickname";
            this.textNickname.Size = new System.Drawing.Size(184, 20);
            this.textNickname.TabIndex = 0;
            this.textNickname.TextChanged += new System.EventHandler(this.textNickname_TextChanged);
            // 
            // identdCheck
            // 
            this.identdCheck.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.identdCheck.Location = new System.Drawing.Point(8, 64);
            this.identdCheck.Name = "identdCheck";
            this.identdCheck.Size = new System.Drawing.Size(136, 16);
            this.identdCheck.TabIndex = 2;
            this.identdCheck.Text = "Enable Identity Server";
            this.identdCheck.CheckedChanged += new System.EventHandler(this.identdCheck_CheckedChanged);
            // 
            // label7
            // 
            this.label7.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.label7.Location = new System.Drawing.Point(8, 112);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(72, 16);
            this.label7.TabIndex = 3;
            this.label7.Text = "Environment:";
            // 
            // label6
            // 
            this.label6.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.label6.Location = new System.Drawing.Point(8, 88);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(72, 16);
            this.label6.TabIndex = 2;
            this.label6.Text = "User ID:";
            // 
            // label5
            // 
            this.label5.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.label5.Location = new System.Drawing.Point(8, 32);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(72, 16);
            this.label5.TabIndex = 1;
            this.label5.Text = "Real Name:";
            // 
            // label4
            // 
            this.label4.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.label4.Location = new System.Drawing.Point(8, 8);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(72, 16);
            this.label4.TabIndex = 0;
            this.label4.Text = "Nickname:";
            // 
            // tabFont
            // 
            this.tabFont.Controls.Add(this.labelFontsChannelsSize);
            this.tabFont.Controls.Add(this.labelFontsChannelsName);
            this.tabFont.Controls.Add(this.btnFontsChannels);
            this.tabFont.Controls.Add(this.label10);
            this.tabFont.Controls.Add(this.btnFontsUserList);
            this.tabFont.Controls.Add(this.labelFontsUserListSize);
            this.tabFont.Controls.Add(this.labelFontsUserListName);
            this.tabFont.Controls.Add(this.label9);
            this.tabFont.Controls.Add(this.labelFontsChatFontSize);
            this.tabFont.Controls.Add(this.labelFontsChatFontName);
            this.tabFont.Controls.Add(this.btnFontsChatFont);
            this.tabFont.Controls.Add(this.label8);
            this.tabFont.Location = new System.Drawing.Point(4, 22);
            this.tabFont.Name = "tabFont";
            this.tabFont.Size = new System.Drawing.Size(272, 218);
            this.tabFont.TabIndex = 2;
            this.tabFont.Text = "Fonts";
            // 
            // labelFontsChannelsSize
            // 
            this.labelFontsChannelsSize.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.labelFontsChannelsSize.Location = new System.Drawing.Point(72, 24);
            this.labelFontsChannelsSize.Name = "labelFontsChannelsSize";
            this.labelFontsChannelsSize.Size = new System.Drawing.Size(120, 16);
            this.labelFontsChannelsSize.TabIndex = 11;
            this.labelFontsChannelsSize.Text = "-";
            // 
            // labelFontsChannelsName
            // 
            this.labelFontsChannelsName.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.labelFontsChannelsName.Location = new System.Drawing.Point(72, 8);
            this.labelFontsChannelsName.Name = "labelFontsChannelsName";
            this.labelFontsChannelsName.Size = new System.Drawing.Size(120, 16);
            this.labelFontsChannelsName.TabIndex = 10;
            this.labelFontsChannelsName.Text = "-";
            // 
            // btnFontsChannels
            // 
            this.btnFontsChannels.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.btnFontsChannels.Location = new System.Drawing.Point(200, 8);
            this.btnFontsChannels.Name = "btnFontsChannels";
            this.btnFontsChannels.Size = new System.Drawing.Size(64, 24);
            this.btnFontsChannels.TabIndex = 9;
            this.btnFontsChannels.Text = "Change";
            this.btnFontsChannels.Click += new System.EventHandler(this.btnFontsChannels_Click);
            // 
            // label10
            // 
            this.label10.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.label10.Location = new System.Drawing.Point(8, 8);
            this.label10.Name = "label10";
            this.label10.Size = new System.Drawing.Size(56, 16);
            this.label10.TabIndex = 8;
            this.label10.Text = "Channels:";
            // 
            // btnFontsUserList
            // 
            this.btnFontsUserList.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.btnFontsUserList.Location = new System.Drawing.Point(200, 88);
            this.btnFontsUserList.Name = "btnFontsUserList";
            this.btnFontsUserList.Size = new System.Drawing.Size(64, 24);
            this.btnFontsUserList.TabIndex = 7;
            this.btnFontsUserList.Text = "Change";
            this.btnFontsUserList.Click += new System.EventHandler(this.btnFontsUserList_Click);
            // 
            // labelFontsUserListSize
            // 
            this.labelFontsUserListSize.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.labelFontsUserListSize.Location = new System.Drawing.Point(72, 104);
            this.labelFontsUserListSize.Name = "labelFontsUserListSize";
            this.labelFontsUserListSize.Size = new System.Drawing.Size(120, 16);
            this.labelFontsUserListSize.TabIndex = 6;
            this.labelFontsUserListSize.Text = "-";
            // 
            // labelFontsUserListName
            // 
            this.labelFontsUserListName.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.labelFontsUserListName.Location = new System.Drawing.Point(72, 88);
            this.labelFontsUserListName.Name = "labelFontsUserListName";
            this.labelFontsUserListName.Size = new System.Drawing.Size(120, 16);
            this.labelFontsUserListName.TabIndex = 5;
            this.labelFontsUserListName.Text = "-";
            // 
            // label9
            // 
            this.label9.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.label9.Location = new System.Drawing.Point(8, 88);
            this.label9.Name = "label9";
            this.label9.Size = new System.Drawing.Size(56, 16);
            this.label9.TabIndex = 4;
            this.label9.Text = "User List:";
            // 
            // labelFontsChatFontSize
            // 
            this.labelFontsChatFontSize.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.labelFontsChatFontSize.Location = new System.Drawing.Point(72, 64);
            this.labelFontsChatFontSize.Name = "labelFontsChatFontSize";
            this.labelFontsChatFontSize.Size = new System.Drawing.Size(120, 16);
            this.labelFontsChatFontSize.TabIndex = 3;
            this.labelFontsChatFontSize.Text = "-";
            // 
            // labelFontsChatFontName
            // 
            this.labelFontsChatFontName.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.labelFontsChatFontName.Location = new System.Drawing.Point(72, 48);
            this.labelFontsChatFontName.Name = "labelFontsChatFontName";
            this.labelFontsChatFontName.Size = new System.Drawing.Size(120, 16);
            this.labelFontsChatFontName.TabIndex = 2;
            this.labelFontsChatFontName.Text = "-";
            // 
            // btnFontsChatFont
            // 
            this.btnFontsChatFont.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.btnFontsChatFont.Location = new System.Drawing.Point(200, 48);
            this.btnFontsChatFont.Name = "btnFontsChatFont";
            this.btnFontsChatFont.Size = new System.Drawing.Size(64, 24);
            this.btnFontsChatFont.TabIndex = 1;
            this.btnFontsChatFont.Text = "Change";
            this.btnFontsChatFont.Click += new System.EventHandler(this.btnFontsChatFont_Click);
            // 
            // label8
            // 
            this.label8.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.label8.Location = new System.Drawing.Point(8, 48);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(56, 16);
            this.label8.TabIndex = 0;
            this.label8.Text = "Chat:";
            // 
            // tabRobots
            // 
            this.tabRobots.Controls.Add(this.btnRobotOptions);
            this.tabRobots.Controls.Add(this.listRobots);
            this.tabRobots.Location = new System.Drawing.Point(4, 22);
            this.tabRobots.Name = "tabRobots";
            this.tabRobots.Size = new System.Drawing.Size(272, 218);
            this.tabRobots.TabIndex = 3;
            this.tabRobots.Text = "Plugins";
            // 
            // btnRobotOptions
            // 
            this.btnRobotOptions.Enabled = false;
            this.btnRobotOptions.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.btnRobotOptions.Location = new System.Drawing.Point(104, 191);
            this.btnRobotOptions.Name = "btnRobotOptions";
            this.btnRobotOptions.Size = new System.Drawing.Size(64, 24);
            this.btnRobotOptions.TabIndex = 1;
            this.btnRobotOptions.Text = "Options";
            this.btnRobotOptions.Click += new System.EventHandler(this.btnRobotOptions_Click);
            // 
            // listRobots
            // 
            this.listRobots.Location = new System.Drawing.Point(8, 8);
            this.listRobots.Name = "listRobots";
            this.listRobots.Size = new System.Drawing.Size(256, 173);
            this.listRobots.Sorted = true;
            this.listRobots.TabIndex = 0;
            this.listRobots.SelectedIndexChanged += new System.EventHandler(this.listRobots_ListSelChanged);
            // 
            // closeButton
            // 
            this.closeButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.closeButton.Location = new System.Drawing.Point(224, 258);
            this.closeButton.Name = "closeButton";
            this.closeButton.Size = new System.Drawing.Size(64, 24);
            this.closeButton.TabIndex = 1;
            this.closeButton.Text = "Close";
            this.closeButton.Click += new System.EventHandler(this.closeButton_Click);
            // 
            // fontDialog
            // 
            this.fontDialog.FontMustExist = true;
            this.fontDialog.ShowEffects = false;
            // 
            // Login
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(296, 294);
            this.Controls.Add(this.closeButton);
            this.Controls.Add(this.tabControl);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.MaximizeBox = false;
            this.Name = "Login";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Login";
            this.Load += new System.EventHandler(this.Login_Load);
            this.tabControl.ResumeLayout(false);
            this.tabServer.ResumeLayout(false);
            this.tabServer.PerformLayout();
            this.tabIdentity.ResumeLayout(false);
            this.tabIdentity.PerformLayout();
            this.tabFont.ResumeLayout(false);
            this.tabRobots.ResumeLayout(false);
            this.ResumeLayout(false);

		}
		#endregion

		private void Login_ListSelChanged(object sender, System.EventArgs e)
		{
			var entry = Settings.Instance.Servers.Listing[serverEntry.SelectedIndex];

			if (entry != null)
			{
				textHost.Text = entry.Host;
				textDescribe.Text = entry.Description;
				textPorts.Text = entry.PortRange;
                chkSSL.Checked = entry.SSL;
			}
			else
			{
				textHost.Text = "";
				textDescribe.Text = "";
				textPorts.Text = "";
                chkSSL.Checked = false;
			}

			Settings.Instance.Servers.Default = textDescribe.Text;
		}

		private void RefreshFontSettings()
		{
            labelFontsChannelsName.Text = Settings.Instance.Fonts.Channels.Name;
            labelFontsChannelsSize.Text = Settings.Instance.Fonts.Channels.Size.ToString();
            labelFontsChatFontName.Text = Settings.Instance.Fonts.ChatText.Name;
            labelFontsChatFontSize.Text = Settings.Instance.Fonts.ChatText.Size.ToString();
            labelFontsUserListName.Text = Settings.Instance.Fonts.UserList.Name;
            labelFontsUserListSize.Text = Settings.Instance.Fonts.UserList.Size.ToString();
		}

		private void Login_Load(object sender, EventArgs e)
		{
			// plugin listing
			foreach(Plugins.Manager.Plugin plugin in main.PluginList)
				{ listRobots.Items.Add(plugin); }

			// font settings
			RefreshFontSettings();

			// identd settings
			identdCheck.Checked = Settings.Instance.Identd.Enabled;
            textEnvironment.Text = Settings.Instance.Identd.OperatingSystem;
            textUserID.Text = Settings.Instance.Identd.UserID;

			// user settings
            textNickname.Text = Settings.Instance.UserInfo.Nickname;
            textRealName.Text = Settings.Instance.UserInfo.RealName;

			// server listing
			int selected = -1;

            foreach (var se in Settings.Instance.Servers.Listing)
			{
				int ret = serverEntry.Items.Add(se.ToString());

                if (se.Description == Settings.Instance.Servers.Default)
					{ selected = ret; }
			}

			serverEntry.SelectedValueChanged += new EventHandler(Login_ListSelChanged);
			serverEntry.SelectedIndex = selected;
		}

		private void clearButton_Click(object sender, System.EventArgs e)
		{
			textHost.Text = "";
			textDescribe.Text = "";
			textPorts.Text = "";
		}

		private void editButton_Click(object sender, System.EventArgs e)
		{
			int index = serverEntry.SelectedIndex;

			if (index > -1)
			{
				if (textHost.Text.Trim() != "")
				{
					var entry = Settings.Instance.Servers.Listing[index];

					entry.Host = textHost.Text.Trim();
					entry.Description = textDescribe.Text.Trim();
					entry.PortRange = textPorts.Text.Trim();
                    entry.SSL = chkSSL.Checked;

					serverEntry.Items[index] = entry.ToString();
				}
				else
				{
					if (MessageBox.Show("You have not specified a host name. Would you " +
						"like to remove this entry?", "Remove", MessageBoxButtons.YesNo,
						MessageBoxIcon.Question) == DialogResult.Yes)
					{
						var s = Settings.Instance.Servers;

						var entries = new ServerEntry[s.Listing.Length - 1];
						Array.Copy(s.Listing, 0, entries, 0, index);
						Array.Copy(s.Listing, index + 1, entries, index, s.Listing.Length - index - 1); 

						s.Listing = entries;
						serverEntry.Items.RemoveAt(index);

						if (serverEntry.Items.Count > 0)
						{
							serverEntry.SelectedIndex = index >= serverEntry.Items.Count
								? serverEntry.Items.Count - 1 : index;
						}
					}
				}
			}
		}

		private void addButton_Click(object sender, System.EventArgs e)
		{
			ServerEntry entry = new ServerEntry();

			if (textHost.Text.Trim() != "")
			{
				entry.Host = textHost.Text.Trim();
				entry.PortRange = textPorts.Text.Trim();
				entry.Description = textDescribe.Text.Trim();
                entry.SSL = chkSSL.Checked;

				ServerEntry[] old_entries = Settings.Instance.Servers.Listing;
				ServerEntry[] new_entries = new ServerEntry[old_entries.Length + 1];
				old_entries.CopyTo(new_entries, 0); new_entries[old_entries.Length] = entry;
				Settings.Instance.Servers.Listing = new_entries;

				serverEntry.SelectedIndex = serverEntry.Items.Add(entry.ToString());
			}
		}

		private void identdCheck_CheckedChanged(object sender, System.EventArgs e)
		{
			Settings.Instance.Identd.Enabled = identdCheck.Checked;
		}

		private void textUserID_TextChanged(object sender, System.EventArgs e)
		{
			Settings.Instance.Identd.UserID = textUserID.Text;
		}

		private void textEnvironment_TextChanged(object sender, System.EventArgs e)
		{
			Settings.Instance.Identd.OperatingSystem = textEnvironment.Text;
		}

		private void textNickname_TextChanged(object sender, System.EventArgs e)
		{
			Settings.Instance.UserInfo.Nickname = textNickname.Text;
		}

		private void textRealName_TextChanged(object sender, System.EventArgs e)
		{
			Settings.Instance.UserInfo.RealName = textRealName.Text;
		}

		private void closeButton_Click(object sender, System.EventArgs e)
		{
			Close();
		}

		private void connectButton_Click(object sender, System.EventArgs e)
		{
			string   Hostname   = textHost.Text.Trim();
			string   PortString = textPorts.Text.Trim();
			string[] PortRanges = PortString.Split(new char[1] { '-' }, 2);
			int      Port;
            bool     SSL = chkSSL.Checked;

			if (Hostname == "")
			{
				MessageBox.Show("You must specify a host to connect to.",
					"No Host Specified", MessageBoxButtons.OK,
					MessageBoxIcon.Warning);
				return;
			}

			if (PortString == "")
			{
				if (MessageBox.Show("You have not specified a port. Shall I try to " +
					"connect on the default IRC port, 6667?", "No Port Specified",
					MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
				{
					Port = 6667;
				}
				else
				{
					return;
				}
			}
			else
			{
				try
				{
					if (PortRanges.Length == 2)
					{
						int PortMin = int.Parse(PortRanges[0]);
						int PortMax = int.Parse(PortRanges[1]);

						Port = new Random().Next(PortMin, PortMax);
					}
					else
					{
						Port = int.Parse(PortRanges[0]);
					}
				}
				catch
				{
					MessageBox.Show("Port ranges must either specify a " +
						"number or a range of values.", "Invalid Port Range",
						MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
					return;
				}
			}

			if (Port < IPEndPoint.MinPort || Port > IPEndPoint.MaxPort)
			{
				MessageBox.Show(string.Format("The port number must be between " +
					"{0} and {1}.", IPEndPoint.MinPort, IPEndPoint.MaxPort),
					"Invalid Port Number", MessageBoxButtons.OK,
					MessageBoxIcon.Exclamation);
				return;
			}

			Cursor = Cursors.WaitCursor;

			if (main.ConnectTo(Hostname, Port, SSL))
			{
				main.Connection.LogIn(Settings.Instance.Identd.UserID,
					Settings.Instance.UserInfo.RealName,
					Settings.Instance.UserInfo.Nickname);
				Close();
			}
			else
			{
				MessageBox.Show(string.Format("Unable to connect to the server '{0}'.",
					Hostname), "Connection Failed", MessageBoxButtons.OK,
					MessageBoxIcon.Exclamation);
			}

			Cursor = Cursors.Default;
		}

		private void UpdateFontData(ref Logic.FontSetting s, Font f)
		{
			fontDialog.Font = f;

			if (fontDialog.ShowDialog() == DialogResult.OK)
			{
				s.Name = fontDialog.Font.Name;
				s.Size = fontDialog.Font.Size;
				main.UpdateFonts();
				RefreshFontSettings();
			}
		}

		private void btnFontsChatFont_Click(object sender, System.EventArgs e)
		{
			UpdateFontData(ref Settings.Instance.Fonts.ChatText,
				main.Fonts.ChatText);
		}

		private void btnFontsUserList_Click(object sender, System.EventArgs e)
		{
			UpdateFontData(ref Settings.Instance.Fonts.UserList,
				main.Fonts.UserList);
		}

		private void btnFontsChannels_Click(object sender, System.EventArgs e)
		{
			UpdateFontData(ref Settings.Instance.Fonts.Channels,
				main.Fonts.Channels);
		}

		private void listRobots_ListSelChanged(object sender, System.EventArgs e)
		{
			if (listRobots.SelectedItem != null)
			{
				btnRobotOptions.Enabled = ((Plugins.Manager.Plugin)
					listRobots.SelectedItem).Instance is
					Plugins.Client.IPluginOptions;
			}
		}

		private void btnRobotOptions_Click(object sender, System.EventArgs e)
		{
			((Plugins.Client.IPluginOptions)((Plugins.Manager.Plugin)
				listRobots.SelectedItem).Instance).ShowOptions(main);
		}
	}
}
